import { ApiVerb } from 'redux-store-generator';
import { Action, ActionInfo, HandleMethod } from '../types';
export declare const initAxios: (baseUrl: string) => void;
export declare const getCollection: (action: Action, info: ActionInfo) => Promise<{
    data: {};
    nextAction: any;
    stopPropagation: boolean;
}>;
export declare const patchCollectionItem: (action: Action, info: ActionInfo) => Promise<{
    stopPropagation: boolean;
}>;
export declare const deleteCollectionItem: (action: Action, info: ActionInfo) => Promise<{
    data: null;
    stopPropagation: boolean;
}>;
export declare const addCollectionItem: (action: Action, info: ActionInfo) => Promise<{
    nextAction: any;
    stopPropagation: boolean;
}>;
export declare const allVerbs: Record<ApiVerb, any>;
export declare const handleAction: HandleMethod;
