import { get as c, set as D } from "lodash";
import { initializeApp as V } from "firebase/app";
import { getFirestore as L, connectFirestoreEmulator as U, collection as J, getDocs as _, doc as A, setDoc as j, updateDoc as z, deleteDoc as X, getDoc as W } from "firebase/firestore";
import { clearStore as G, generateReducersForStore as q, generateActionTypesDictionaryForStore as K, analyzeStructure as Q, generateActionsForStore as Y } from "redux-store-generator";
import { composeWithDevTools as Z } from "@redux-devtools/extension";
import { combineReducers as tt, applyMiddleware as et, compose as st, createStore as nt } from "redux";
import ot from "redux-saga";
import rt from "axios";
const at = (s, t) => {
  localStorage.setItem(s, t);
}, it = (s) => {
  const t = localStorage.getItem(s);
  return t ? JSON.parse(t) : null;
}, lt = (s, t) => {
  const e = JSON.stringify(t);
  at(s, e);
}, b = () => it("STORE") || {}, H = (s) => {
  lt("STORE", s);
}, m = (s) => {
  const t = b();
  return c(t, s);
}, u = (s, t) => {
  const e = b(), n = c(e, s);
  D(e, s, {
    ...n,
    ...t
  }), H(e);
}, g = (s) => {
  const t = b(), e = s.split("."), n = e.pop(), o = e.join("."), r = c(t, o);
  !n || !(n in r) || (delete r[n], D(t, o, r), H(t));
};
let R = {};
const ct = (s) => {
  R = s;
}, i = (s, t, e) => {
  const n = R[s];
  return ["set", "patch"].includes(t) ? n[t](e.id, e) : n[t](e);
}, ut = (s, t) => {
  let e;
  const { nodeName: n } = t, o = `${n}`, r = m(o);
  return e = i(n, "setAll", r), {
    data: r,
    nextAction: e
  };
}, dt = (s, t) => {
  const { id: e, payload: n = {} } = s, { nodeName: o } = t, r = `${o}.${e}`;
  return u(r, n), {};
}, pt = (s, t) => {
  const { id: e } = s, { nodeName: n } = t, o = `${n}.${e}`;
  return g(o), {
    data: null
  };
}, ht = (s, t) => {
  const { payload: e = {} } = s, { nodeName: n } = t, o = s.id ?? e.id, r = `${n}.${o}`;
  return u(r, e), {
    nextAction: i(n, "set", e)
  };
}, mt = {
  get: ut,
  patch: dt,
  delete: pt,
  add: ht,
  clear: null,
  clearItems: null,
  deleteItem: null,
  getItems: null,
  patchItem: null,
  pop: null,
  popItem: null,
  push: null,
  pushItem: null,
  pushMany: null,
  pushManyItems: null,
  set: null,
  setAll: null,
  setItems: null,
  setMany: null
}, gt = async (s, t) => {
  const { verb: e } = t, n = mt[e];
  if (!n)
    return !1;
  const o = await n(s, t), { nextAction: r } = o;
  return {
    nextAction: r,
    stopPropagation: !1
  };
}, It = (s, t) => {
  let e;
  const { nodeName: n } = t, o = `${n}`, r = m(o);
  return e = i(n, "setAll", r), {
    data: r,
    nextAction: e
  };
}, ft = (s, t) => {
  const { id: e, payload: n = {} } = s, { nodeName: o } = t, r = `${o}.${e}`;
  return u(r, n), {};
}, wt = (s, t) => {
  const { id: e } = s, { nodeName: n } = t, o = `${n}.${e}`;
  return g(o), {
    data: null
  };
}, yt = (s, t) => {
  const { payload: e = {} } = s, { nodeName: n } = t, o = s.id ?? e.id, r = `${n}.${o}`;
  return u(r, e), {
    nextAction: i(n, "set", e)
  };
}, $t = {
  get: It,
  patch: ft,
  delete: wt,
  add: yt,
  clear: null,
  clearItems: null,
  deleteItem: null,
  getItems: null,
  patchItem: null,
  pop: null,
  popItem: null,
  push: null,
  pushItem: null,
  pushMany: null,
  pushManyItems: null,
  set: null,
  setAll: null,
  setItems: null,
  setMany: null
}, xt = async (s, t) => {
  const { verb: e } = t, n = $t[e];
  if (!n)
    return !1;
  const o = await n(s, t), { nextAction: r } = o;
  return {
    nextAction: r,
    stopPropagation: !1
  };
}, At = (s, t) => {
  let e;
  const { nodeName: n } = t, o = `${n}`, r = m(o);
  return e = i(n, "setAll", r), {
    data: r,
    nextAction: e
  };
}, St = (s, t) => {
  const { id: e, payload: n = {} } = s, { nodeName: o } = t, r = `${o}.${e}`;
  return u(r, n), {};
}, Mt = (s, t) => {
  const { id: e } = s, { nodeName: n } = t, o = `${n}.${e}`;
  return g(o), {
    data: null
  };
}, Ct = (s, t) => {
  const { payload: e = {} } = s, { nodeName: n } = t, o = s.id ?? e.id, r = `${n}.${o}`;
  return u(r, e), {
    nextAction: i(n, "set", e)
  };
}, bt = {
  get: At,
  patch: St,
  delete: Mt,
  add: Ct,
  clear: null,
  clearItems: null,
  deleteItem: null,
  getItems: null,
  patchItem: null,
  pop: null,
  popItem: null,
  push: null,
  pushItem: null,
  pushMany: null,
  pushManyItems: null,
  set: null,
  setAll: null,
  setItems: null,
  setMany: null
}, Et = async (s, t) => {
  const { verb: e } = t, n = bt[e];
  if (!n)
    return !1;
  const o = await n(s, t), { nextAction: r } = o;
  return {
    nextAction: r,
    stopPropagation: !1
  };
};
class I {
  constructor(t) {
    this.output = {}, this.response = {}, this.transformers = [], this.timestampStart = 0, this.output = {
      request: t
    }, this.timestampStart = Date.now();
  }
  withAxiosResponse(t) {
    return this.response = t, this;
  }
  withData(t) {
    return this.output.data = t, this;
  }
  withIsSuccess(t) {
    return this.output.isSuccess = t, this;
  }
  withIsError(t) {
    return this.output.isError = t, this;
  }
  withErrorType(t) {
    return this.output.errorType = t, this;
  }
  withErrorMessage(t) {
    return this.output.errorMessage = t, this;
  }
  withStatus(t) {
    return this.output.status = t, this;
  }
  withTransformer(t) {
    return t ? (this.transformers.push(t), this) : this;
  }
  build() {
    if (!this.response)
      return this.output;
    this.output.status = this.response.status, this.output.statusText = this.response.statusText, this.output.headers = this.response.headers;
    const t = Date.now();
    return this.output.timestampStart = this.timestampStart, this.output.timestampEnd = t, this.output.duration = t - this.timestampStart, this.output.data = this.response.data || this.output.data, this.transformers.length && (this.output.data = this.transformers.reduce((e, n) => n(e), this.output.data)), this.output;
  }
}
let N, p;
const Nt = (s, t) => {
  N = V(s, "redux-connected"), p = L(N), t && U(p, "localhost", 8080);
}, vt = (s) => {
  p = s;
}, Pt = async (s) => {
  const t = new I({}), e = J(p, s);
  try {
    const o = (await _(e)).docs.map((r) => r.data());
    f(t, o);
  } catch (n) {
    w(t, n);
  }
  return t.build();
}, Tt = async (s) => {
  const t = new I({}), e = A(p, s);
  try {
    const o = (await W(e)).data();
    f(t, o);
  } catch (n) {
    w(t, n);
  }
  return t.build();
}, Dt = async (s, t) => {
  const e = new I({}), n = A(p, s);
  try {
    await j(n, t), f(e, t);
  } catch (o) {
    console.log("err =>", o), w(e, o);
  }
  return e.build();
}, Ht = async (s, t) => {
  const e = new I({}), n = A(p, s);
  try {
    await z(n, t);
    const o = await Tt(s);
    f(e, o);
  } catch (o) {
    console.log("err =>", o), w(e, o);
  }
  return e.build();
}, Rt = async (s) => {
  const t = new I({}), e = A(p, s);
  try {
    await X(e), f(t, {});
  } catch (n) {
    w(t, n);
  }
  return t.build();
}, f = (s, t) => {
  s.withData(t).withIsSuccess(!0);
}, w = (s, t) => {
  s.withErrorMessage(t.message).withIsError(!0).withIsSuccess(!1);
};
class Bt {
  constructor(t) {
    this.definition = {
      name: "",
      initialState: {},
      reducers: {},
      middlewares: [],
      enhancers: [],
      sagas: [],
      sagasContext: {},
      enableDevtoolsExtension: !1,
      sagaMonitor: null
    }, this.preMiddlewares = [], this.postMiddlewares = [], this.preBuildHooks = [], this.postBuildHooks = [], this.autoClear = !1, this.definition.name = t;
  }
  withInitialState(t) {
    return this.definition.initialState = {
      ...this.definition.initialState,
      ...t
    }, this;
  }
  withPreBuildHook(t) {
    return this.preBuildHooks.push(t), this;
  }
  withPostBuildHook(t) {
    return this.postBuildHooks.push(t), this;
  }
  withReducers(t) {
    return this.definition.reducers = {
      ...this.definition.reducers,
      ...t
    }, this;
  }
  withMiddlewares(t) {
    const e = Array.isArray(t) ? t : [t];
    return this.definition.middlewares = [
      ...this.definition.middlewares,
      ...e
    ], this;
  }
  withEnhancers(t) {
    const e = Array.isArray(t) ? t : [t];
    return this.definition.enhancers = [
      ...this.definition.enhancers,
      ...e
    ], this;
  }
  withPreMiddlewares(...t) {
    return this.preMiddlewares = t, this;
  }
  withPostMiddlewares(...t) {
    return this.postMiddlewares = t, this;
  }
  withSagas(...t) {
    return this.definition.sagas = [...this.definition.sagas, ...t], this;
  }
  withSagaMonitor(t) {
    return this.definition.sagaMonitor = t, this;
  }
  withSagaContext(t) {
    return this.definition.sagasContext = {
      ...this.definition.sagasContext,
      ...t
    }, this;
  }
  clearSagas() {
    return this.definition.sagas = [], this;
  }
  withDevtoolsExtensions(t) {
    return this.definition.enableDevtoolsExtension = t === !0, this;
  }
  withAutoClear() {
    return this.autoClear = !0, this;
  }
  getSagaMiddleware() {
    return this.sagaMiddleware;
  }
  clear(t) {
    G(t);
  }
  build() {
    this.preBuildHooks.forEach((a) => {
      a(r);
    }), this.definition.sagas.length > 0 && (this.sagaMiddleware = ot({
      context: {
        ...this.definition.sagasContext
      },
      sagaMonitor: this.definition.sagaMonitor
    }), this.withMiddlewares(this.sagaMiddleware));
    const t = tt(this.definition.reducers), e = et(
      ...this.preMiddlewares,
      ...this.definition.middlewares,
      ...this.postMiddlewares
    ), o = (this.definition.enableDevtoolsExtension ? Z : st)(
      e,
      ...this.definition.enhancers
    ), r = nt(
      t,
      this.definition.initialState,
      o
    );
    return this.postBuildHooks.forEach((a) => {
      a(r);
    }), this.definition.sagas.forEach((a) => {
      this.sagaMiddleware.run(a);
    }), this.autoClear && this.clear(r), r;
  }
}
const kt = (s) => {
  const { type: t } = s, e = x.actionTypes[t];
  if (!e)
    return null;
  const { nodeName: n } = e, o = x.structure[n];
  return {
    ...e,
    noteType: o
  };
}, Ot = (s) => (t) => async (e) => {
  const n = kt(e);
  if (!n)
    return t(e);
  const { verb: o, isLocal: r, nodeName: a } = n, l = c(d, "adapter.optimisticNodes", []).includes(a) || c(d, "adapter.optimisticVerbs", []).includes(o), h = he(), M = c(d, "adapter.ignoreNodes", []).includes(
    a
  );
  if (r || !h || M)
    return t(e);
  l && (t(e), o === "add" && s.dispatch(Ft(e)));
  const E = await h(e, n), { nextAction: $ } = E;
  if ($ && s.dispatch($), !l)
    return t(e);
}, Ft = (s) => {
  const e = { id: c(s, "payload.id", ""), ...s };
  return e.type = e.type.replace("ADD_", "SET_"), e;
}, v = [], Vt = (s) => (t) => (e) => {
  v.includes(e.type) && console.log("dispatching", e.type, e);
  const n = t(e);
  return v.includes(e.type) && console.log("next state", s.getState()), n;
}, Lt = (s = {}, t) => t;
class Ut {
  constructor(t) {
    this.instance = rt.create({ baseURL: t });
  }
  run(t, e, n = {}) {
    return new Promise((o) => {
      const r = {
        isSuccess: !0,
        isError: !1,
        data: [],
        error: ""
      };
      return this.instance({
        method: t,
        url: e,
        data: n,
        headers: {
          "Access-Control-Allow-Origin": "*",
          "Access-Control-Allow-Methods": "GET,PUT,POST,DELETE,PATCH,OPTIONS",
          contentType: "application/json"
        }
      }).then((a) => {
        r.isSuccess = !0, r.data = a.data, o(r);
      }).catch((a) => {
        r.isSuccess = !1, r.isError = !0, r.error = a.message, o(r);
      });
    });
  }
}
const B = (s, t = "id") => !s || !Array.isArray(s) ? {} : s.reduce((e, n) => (e[n[t]] = n, e), {});
let y;
const Jt = (s) => {
  y = new Ut(s);
}, _t = async (s, t) => {
  let e, n = {};
  const { nodeName: o } = t, r = `${o}`, a = await y.run("get", r);
  return a.isSuccess && (n = B(a.data, "id"), e = i(o, "setAll", n)), {
    data: n,
    nextAction: e,
    stopPropagation: !a.isError
  };
}, jt = async (s, t) => {
  const { id: e, payload: n = {} } = s, { nodeName: o } = t, r = `${o}/${e}`, a = await y.run("patch", r, n);
  return a.isSuccess, {
    stopPropagation: !a.isError
  };
}, zt = async (s, t) => {
  const { id: e } = s, { nodeName: n } = t, o = `${n}/${e}`, r = await y.run("delete", o);
  return r.isSuccess, {
    data: null,
    stopPropagation: !r.isError
  };
}, Xt = async (s, t) => {
  let e;
  const { payload: n = {} } = s, { nodeName: o } = t, r = s.id ?? n.id, a = `${o}/${r}`, l = await y.run("post", a, n);
  return l.isSuccess && (e = i(o, "set", n)), {
    nextAction: e,
    stopPropagation: !l.isError
  };
}, Wt = {
  get: _t,
  patch: jt,
  delete: zt,
  add: Xt,
  clear: null,
  clearItems: null,
  deleteItem: null,
  getItems: null,
  patchItem: null,
  pop: null,
  popItem: null,
  push: null,
  pushItem: null,
  pushMany: null,
  pushManyItems: null,
  set: null,
  setAll: null,
  setItems: null,
  setMany: null
}, Gt = async (s, t) => {
  const { verb: e } = t, n = Wt[e];
  if (!n)
    return !1;
  const o = await n(s, t), { nextAction: r, stopPropagation: a } = o;
  return {
    nextAction: r,
    stopPropagation: a
  };
};
let d = {}, x = {
  actionTypes: {},
  structure: {}
}, k;
const Ae = (s) => {
  d = s;
  const {
    sagas: t,
    initialState: e,
    firebaseConfig: n,
    fireStore: o,
    useEmulator: r,
    useLocalInstance: a
  } = s, l = new Bt("gdi"), h = {
    ...e
  }, M = q(h);
  switch (l.withReducers(M).withReducers({ _lastAction: Lt }).withMiddlewares([Vt, Ot]).withInitialState(h).withDevtoolsExtensions(!0), t && l.withSagas(t), k = l.getSagaMiddleware(), x.actionTypes = K(h), x.structure = Q(h), c(d, "adapter.providerType", "none")) {
    case "fireStore":
      o ? vt(o) : n && Nt(n, r);
      break;
    case "rest":
      const F = c(d, "adapter.localInstanceUrl", "");
      Jt(F + "/data");
      break;
  }
  const $ = Y(e);
  return ct($), l;
}, Se = (s) => {
  k.run(s);
};
let C, P = "", O = "";
const Me = (s) => {
  C = s, c(C, "isAnonymous", !0), P = c(C, "uid", ""), O = c(d, "adapter.scope", "").replace("${uid}", P);
}, S = (s) => `${O}/${s}`, qt = async (s, t) => {
  let e, n = {};
  const { nodeName: o } = t, r = S(`${o}`), a = await Pt(r);
  return a.isSuccess && (n = B(a.data, "id"), e = i(o, "setAll", n)), {
    data: n,
    nextAction: e,
    stopPropagation: !a.isError
  };
}, Kt = async (s, t) => {
  const { id: e, payload: n = {} } = s, { nodeName: o } = t, r = S(`${o}/${e}`), a = await Ht(r, n);
  return a.isSuccess, {
    stopPropagation: !a.isError
  };
}, Qt = async (s, t) => {
  const { id: e } = s, { nodeName: n } = t, o = S(`${n}/${e}`), r = await Rt(o);
  return r.isSuccess, {
    data: null,
    stopPropagation: !r.isError
  };
}, Yt = async (s, t) => {
  let e;
  const { payload: n = {} } = s, { nodeName: o } = t, r = s.id ?? n.id, a = S(`${o}/${r}`), l = await Dt(a, n);
  return l.isSuccess && (e = i(o, "set", n)), {
    nextAction: e,
    stopPropagation: !l.isError
  };
}, Zt = {
  get: qt,
  patch: Kt,
  delete: Qt,
  add: Yt,
  clear: null,
  clearItems: null,
  deleteItem: null,
  getItems: null,
  patchItem: null,
  pop: null,
  popItem: null,
  push: null,
  pushItem: null,
  pushMany: null,
  pushManyItems: null,
  set: null,
  setAll: null,
  setItems: null,
  setMany: null
}, te = async (s, t) => {
  const { verb: e } = t, n = Zt[e];
  if (!n)
    return !1;
  const o = await n(s, t), { nextAction: r, stopPropagation: a } = o;
  return {
    nextAction: r,
    stopPropagation: a
  };
}, ee = (s, t) => {
  let e;
  const { nodeName: n } = t, o = `${n}`, r = m(o);
  return e = i(n, "setAll", r), {
    data: r,
    nextAction: e
  };
}, se = (s, t) => {
  const { id: e, payload: n = {} } = s, { nodeName: o } = t, r = `${o}.${e}`;
  return u(r, n), {};
}, ne = (s, t) => {
  const { id: e } = s, { nodeName: n } = t, o = `${n}.${e}`;
  return g(o), {
    data: null
  };
}, oe = (s, t) => {
  const { payload: e = {} } = s, { nodeName: n } = t, o = s.id ?? e.id, r = `${n}.${o}`;
  return u(r, e), {
    nextAction: i(n, "set", e)
  };
}, re = {
  get: ee,
  patch: se,
  delete: ne,
  add: oe,
  clear: null,
  clearItems: null,
  deleteItem: null,
  getItems: null,
  patchItem: null,
  pop: null,
  popItem: null,
  push: null,
  pushItem: null,
  pushMany: null,
  pushManyItems: null,
  set: null,
  setAll: null,
  setItems: null,
  setMany: null
}, ae = async (s, t) => {
  const { verb: e } = t, n = re[e];
  if (!n)
    return !1;
  const o = await n(s, t), { nextAction: r } = o;
  return {
    nextAction: r,
    stopPropagation: !1
  };
}, ie = (s, t) => {
  let e;
  const { nodeName: n } = t, o = `${n}`, r = m(o);
  return e = i(n, "setAll", r), {
    data: r,
    nextAction: e
  };
}, le = (s, t) => {
  const { id: e, payload: n = {} } = s, { nodeName: o } = t, r = `${o}.${e}`;
  return u(r, n), {};
}, ce = (s, t) => {
  const { id: e } = s, { nodeName: n } = t, o = `${n}.${e}`;
  return g(o), {
    data: null
  };
}, ue = (s, t) => {
  const { payload: e = {} } = s, { nodeName: n } = t, o = s.id ?? e.id, r = `${n}.${o}`;
  return u(r, e), {
    nextAction: i(n, "set", e)
  };
}, de = {
  get: ie,
  patch: le,
  delete: ce,
  add: ue,
  clear: null,
  clearItems: null,
  deleteItem: null,
  getItems: null,
  patchItem: null,
  pop: null,
  popItem: null,
  push: null,
  pushItem: null,
  pushMany: null,
  pushManyItems: null,
  set: null,
  setAll: null,
  setItems: null,
  setMany: null
}, T = async (s, t) => {
  const { verb: e } = t, n = de[e];
  if (!n)
    return !1;
  const o = await n(s, t), { nextAction: r } = o;
  return {
    nextAction: r,
    stopPropagation: !1
  };
}, pe = {
  bridge: gt,
  cli: xt,
  direct: Et,
  fireStore: te,
  json: ae,
  localStorage: T,
  none: T,
  rest: Gt
}, he = () => {
  const s = c(d, "adapter.providerType", "none");
  return pe[s];
};
export {
  pe as allProviders,
  Ae as initConnected,
  Se as runSaga,
  Me as setUser
};
//# sourceMappingURL=redux-connected.es.js.map
