type Method = 'get' | 'post' | 'put' | 'delete' | 'patch';
type Response = {
    isSuccess: boolean;
    isError: boolean;
    data: Json[];
    error: string;
};
export declare class Axios {
    private instance;
    constructor(baseUrl: string);
    run(method: Method, path: string, data?: Json): Promise<Response>;
}
export {};
