export let actions = {};
export const setActions = (value) => {
    actions = value;
};
export const getActionForNode = (nodeName, verb, data) => {
    const actionsForNode = actions[nodeName];
    if (['set', 'patch'].includes(verb)) {
        return actionsForNode[verb](data.id, data);
    }
    else {
        return actionsForNode[verb](data);
    }
};
