import { meta } from '../store/store';
export const analyzeAction = (action) => {
    const { type } = action;
    const actionInfo = meta.actionTypes[type];
    if (!actionInfo) {
        return null;
    }
    const { nodeName } = actionInfo;
    const noteType = meta.structure[nodeName];
    return {
        ...actionInfo,
        noteType,
    };
};
