import { get } from 'lodash';
import { config } from '../store/store';
export let user, uid = '', isAnonymous = true, isReady = false, scope = '';
export const setUser = (value) => {
    user = value;
    isAnonymous = get(user, 'isAnonymous', true);
    uid = get(user, 'uid', '');
    scope = get(config, 'adapter.scope', '').replace('${uid}', uid);
    isReady = true;
};
export const getUser = () => {
    return user;
};
