export const arrayToObject = (array, key = 'id') => {
    if (!array || !Array.isArray(array)) {
        return {};
    }
    return array.reduce((obj, item) => {
        obj[item[key]] = item;
        return obj;
    }, {});
};
